#include "descriptor/descriptor.h"

int main(void) {

  ITEM	glass,ceramic, redceramic, brown, yellow, green, gray, standard;
  ITEM	teapot_glass, cup1, caffettiera;
  ITEM	scene;
  ITEM   sedia, cuscino, front, paretesx, floor, paretedx, sofitto, tavolo, sedia_letto;
  ITEM   vetro, bed, finestra, tovaglia, cuscinoletto, cuscinoletto2, coperta, cuscino_sedia, 							cuscino_sedia_letto;
  ITEM   quadrolungo, dipintolungo, quadrolargo, dipintolargo, quadro1, dipinto1, quadro2, dipinto2;

  char * texture_legno = "textures/legno5.hr";
  char * texture_legno_letto = "textures/wood039.hr";
  char * texture_coperta = "textures/cloth2.hr";
  char * texture_cuscino = "textures/cuscino.hr";
  char * texture_pavimento = "textures/Wood24.hr";
  char * texture_paesaggio = "textures/paesaggio1.hr";
  char * texture_seminatore = "textures/seminatore.hr";
  char * texture_cottone = "textures/cottone.hr";
  char * texture_parete = "textures/woodchip.hr";
  char * texture_autoritratto_giovane = "textures/autogiovane.hr";
  char * texture_autoritratto_vecchio = "textures/autovecchio.hr";

  set_background(0,0,0,TRUE);
  set_ambient_light(1,1,1,0.8);
  create_point_light(16.16,15.90,9.39,1,1,1,3.89,20, "light1");
  create_point_light(60,0, 9,1, 1, 1, 4, 20, "light2");
  create_point_light(2.33,-0.25,16.21,1,1,1,3.89,25, "light3");

  /*** ATTRIBUTE glass ***/
  glass = create_attribute("glass");
  set_color(glass,0.68,0.86,1,0.5,0.5);
  set_reflectivity(glass,0.24,2);
  set_transparency(glass,0.87,0.68,1,1.2);

  /*** ATTRIBUTE ceramic ***/
  ceramic = create_attribute("ceramic");
  set_color(ceramic,0.89,0.76,0.65,0.1,0.8);
  set_reflectivity(ceramic,0.2,128);

  /*** ATTRIBUTE redceramic ***/
  redceramic = create_attribute("redceramic");
  set_color(redceramic,1,0,0,0.1,0.8);
  set_reflectivity(redceramic,0.2,128);

  /*** ATTRIBUTE brown ***/
  brown = create_attribute("brown");
  set_color(brown,0.93,0.23,0.03,0.2,0.8);
  set_reflectivity(brown,0.17,15);

  /*** ATTRIBUTE yellow ***/
  yellow = create_attribute("yellow");
  set_color(yellow,1,1,0,0.2,0.8);
  set_reflectivity(yellow,0.3,10);

   /*** ATTRIBUTE green ***/
  green = create_attribute("green");
  set_reflectivity(green,0.3,10);
  set_color(green,0.04,0.4,0,0.1,0.3);

  /*** ATTRIBUTE gray ***/
  gray = create_attribute("gray");
  set_color(gray,1,1,1,0.5,0.0);

  /*** ATTRIBUTE standard ***/
  standard = create_attribute("standard");
  set_color(standard,1,1,1,0,1);
  set_reflectivity(standard,0,2);
  set_transparency(standard,0,0,0,1);

  /* -- Le due sedie --*/
  sedia = read_obj("sediacompleta.obj", "sedia");
  set_translate(sedia,1,-7,0.4);
  set_scale(sedia,1.5,1.5,1.5);
  set_domain_texture(sedia,standard, texture_legno, 0, 1, 0, 1, 1, 0.6, 0.6);

  cuscino_sedia = read_obj("cuscino.obj", "cuscino_sedia");
  set_translate(cuscino_sedia,1,-7,0.4);
  set_scale(cuscino_sedia,1.5,1.5,2);
  set_domain_texture(cuscino_sedia,standard, texture_cuscino, 0, 1, 0, 1, 1, 0.6, 0.6);

  sedia_letto =  create_copy(sedia, "sedia_letto");
  set_z_rotate(sedia_letto,-40,1);
  set_translate(sedia_letto,-8, 11,0.0);

  cuscino_sedia_letto = create_copy(cuscino_sedia, "cuscino_sedia_letto");
  set_z_rotate(cuscino_sedia_letto,-40,1);
  set_translate(cuscino_sedia_letto,-8, 11,0.0);

  /* -- Il tavolo --*/
  tavolo = read_obj("tavolocompleto.obj", "tavolo");
  set_domain_texture(tavolo,standard, texture_legno, 0, 1, 0, 1, 1, 0.6, 0.6);

  /* -- Gli oggetti sul tavolo -- */
  teapot_glass = read_obj("teapot.obj", "glass_teapot");
  set_scale(teapot_glass,0.5,0.5,0.5);
  set_translate(teapot_glass,-7.2,-6,2.7);
  set_attribute(teapot_glass, ceramic);

  cup1 = read_obj("cup.obj", "ceramic_cup");
  set_scale(cup1,0.03,0.03,0.03);
  set_x_rotate(cup1,-55,1);
  set_translate(cup1,-6.2,-7.1,3.8);
  set_attribute(cup1,ceramic);

  caffettiera = read_obj("CaffettieraPiuManico21.obj", "caffettiera");
  set_scale(caffettiera,2, 2, 2);
  set_translate(caffettiera,-6.5,-7.9,3.3);
  set_attribute(caffettiera,redceramic);

  /*-- Il letto con cuscini e coperta --*/
  bed = read_obj("lettotesta.obj", "letto");
  set_scale(bed,2.3,2.3,2.3);
  set_translate(bed,2,5.5,3.2);
  set_projection_texture(bed,standard,texture_legno_letto,1,1,0.4,0.4);

  coperta = read_nurbs("copertaok.db");
  set_scale(coperta,2.3,2.3,2.3);
  set_translate(coperta,2,6,2.6);
  set_attribute(coperta, glass);
  set_domain_texture(coperta,standard, texture_coperta, 0, 1, 0, 1, 1, 0.6, 0.6);

  cuscinoletto = read_obj("cuscino27completo.obj", "cuscinoletto");
  set_scale(cuscinoletto,1.5,1.5,1.5);
  set_z_rotate(cuscinoletto,180,1);
  set_translate(cuscinoletto,-11,7.5,1.6);
  set_attribute(cuscinoletto, gray);
  set_domain_texture(cuscinoletto,standard, texture_cuscino, 0, 1, 0, 1, 1, 0.6, 0.6);

  cuscinoletto2 = create_copy(cuscinoletto, "cuscinoletto2");
  set_translate(cuscinoletto2,0,3,0);

  /* -- La finestra --*/
  finestra = read_obj("finestra.obj", "finestra");
  set_scale(finestra,1.2,1.2,1.6);
  set_translate(finestra,-17.65,-9,3.5);
  set_attribute(finestra, green);

  vetro = read_nurbs("finestravetro.db");
  set_scale(vetro,1.2,1.2,1.6);
  set_translate(vetro,-17.65,-9.1,3.5);
  set_attribute(vetro, yellow);

  /* -- I quadri sulla parete frontale --*/
  quadrolungo = read_obj("quadrolungo.obj", "quadrolungo");
  set_translate(quadrolungo,-14.85,-8,6);
  set_attribute(quadrolungo, brown);

  dipintolungo = read_nurbs("quadrolungo.db");
  set_translate(dipintolungo,-14.849, -7.969,6.01);
  set_attribute(dipintolungo, glass);
  set_domain_texture(dipintolungo,standard, texture_seminatore, 0, 1, 0, 1, 1, 0.6, 0.6);

  quadrolargo = read_obj("quadrolargoconappendino.obj", "quadrolargo");
  set_translate(quadrolargo,-14.85,-1,5.5);
  set_attribute(quadrolargo, brown);

  dipintolargo = read_nurbs("quadrolargo.db");
  set_translate(dipintolargo,-14.849,-1,5.5);
  set_domain_texture(dipintolargo,standard, texture_paesaggio, 0, 1, 0, 1, 1, 0.6, 0.6);

  /* -- I quadri sulla parete destra --*/
  quadro1 = read_obj("quadrolungo.obj", "autoritratto_giovane");
  set_z_rotate(quadro1,90,1);
  set_translate(quadro1,-2, 12.75,5);
  set_attribute(quadro1, brown);

  dipinto1 = read_nurbs("quadrolungo.db");
  set_z_rotate(dipinto1,90,1);
  set_translate(dipinto1,-2, 12.74,5);
  set_domain_texture(dipinto1,standard, texture_autoritratto_giovane, 0, 1, 0, 1, 1, 0.6, 0.6);

  quadro2 = read_obj("quadrolungo.obj", "autoritratto_vecchio");
  set_z_rotate(quadro2,90,1);
  set_translate(quadro2,-6, 12.75,5);
  set_attribute(quadro2, brown);

  dipinto2 = read_nurbs("quadrolungo.db");
  set_z_rotate(dipinto2,90,1);
  set_translate(dipinto2,-6, 12.74,5);
  set_attribute(dipinto2, brown);
  set_domain_texture(dipinto2,standard, texture_autoritratto_vecchio, 0, 1, 0, 1, 1, 0.6, 0.6);

  /* -- La tovaglia appesa sulla parete -- */
  tovaglia = read_nurbs("tovagliaconcurva3d.db");
  set_scale(tovaglia,1.8,1.8,2.0);
  set_z_rotate(tovaglia,180,1);
  set_x_rotate(tovaglia,13,1);
  set_translate(tovaglia,-2,-11,2);
  set_attribute(tovaglia, gray);
  set_domain_texture(tovaglia,standard, texture_cottone, 0, 1, 0, 1, 1, 0.6, 0.6);

  /* -- Le pareti, il soffitto e il pavimento --*/
  floor = read_nurbs("floor.db");
  set_scale(floor,2.3,2.3,1);
  set_translate(floor,12,0,0);
  set_domain_texture(floor,standard, texture_pavimento, 0, 1, 0, 1, 1, 0.6, 0.6);

  sofitto = read_nurbs("floor.db");
  set_scale(sofitto,1.4,1.4,1.4);
  set_x_rotate(sofitto,180,1);
  set_translate(sofitto,2,0,14.7);
  set_attribute(sofitto, gray);

  paretedx = read_nurbs("paretedestra.db");
  set_scale(paretedx,1,1,1.4);
  set_translate(paretedx,-2,0,0);
  set_domain_texture(paretedx,standard, texture_parete, 0, 1, 0, 1, 1, 0.6, 0.6);

  front = create_copy(paretedx, "paretefrontale");
  set_z_rotate(front,90,1);
  set_translate(front,-2,0,0);

  paretesx = create_copy(front, "paretesinistra");
  set_z_rotate(paretesx,90,1);
  set_translate(paretesx,-4,2,0);

  /* -- L'inserimento degli oggetti nella scena -- */
  scene = create_list(teapot_glass, "scene");
  scene = insert_in_list(scene,sedia);
  scene = insert_in_list(scene,cuscino_sedia);
  scene = insert_in_list(scene,sedia_letto);
  scene = insert_in_list(scene,cuscino_sedia_letto);
  scene = insert_in_list(scene,cuscinoletto);
  scene = insert_in_list(scene,cuscinoletto2);
  scene = insert_in_list(scene,vetro);
  scene = insert_in_list(scene,tovaglia);
  scene = insert_in_list(scene,bed);
  scene = insert_in_list(scene,finestra);
  scene = insert_in_list(scene,quadrolungo);
  scene = insert_in_list(scene,quadrolargo);
  scene = insert_in_list(scene,dipintolungo);
  scene = insert_in_list(scene,dipintolargo);
  scene = insert_in_list(scene,quadro1);
  scene = insert_in_list(scene,dipinto1);
  scene = insert_in_list(scene,quadro2);
  scene = insert_in_list(scene,dipinto2);
  scene = insert_in_list(scene,coperta);
  scene = insert_in_list(scene,tavolo);
  scene = insert_in_list(scene,cup1);
  scene = insert_in_list(scene,caffettiera);
  scene = insert_in_list(scene, paretesx);
  scene = insert_in_list(scene,paretedx);
  scene = insert_in_list(scene,floor);
  scene = insert_in_list(scene,sofitto);
  scene = insert_in_list(scene,front);

  save_scene("cameradaletto.md","chambre",scene);
  return(0);
}
